use CGI;

use vars qw/$template $username $mail $iplog_script/;
use CGI qw/:standard :html3 shortcuts a escapeHTML standard html2/;
use CGI::Carp qw(fatalsToBrowser);
use English;
use Fcntl qw/:flock/;
use strict;

my $query = new CGI;

my $thisScript=$0;
my $directory;
my $scriptName;
if ($thisScript =~ /(.*)\/(.*)/) {
  $directory=$1;
  $scriptName=$2;
} else {
  $directory=".";
  $scriptName=$thisScript;
}

################################################################
# Default templates                                            #
################################################################

my $templateTxt = '
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
  <head>
    <META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=iso-8859-15">
    <title>${username}\'s Guestbook</title>
    <style type="text/css">
                <!--
      		.adsense {
			float: left;
			padding-right: 10px;
		}
                -->
    </style>
  </head>

  <body>
    <h1>${username}\'s Guestbook</h1>

<div class="adsense">
<script type="text/javascript"><!--
google_ad_client = "pub-7598568649272102";
google_ad_width = 160;
google_ad_height = 600;
google_ad_format = "160x600_as";
google_ad_type = "text_image";
google_ad_channel ="8765151934";
google_color_border = "336699";
google_color_text = "000000";
google_color_bg = "FFFFFF";
google_color_link = "0000FF";
google_color_url = "008000";
//--></script>
<script type="text/javascript"
  src="http://pagead2.googlesyndication.com/pagead/show_ads.js">
</script>
</div>


<form method="post" action="${scriptname}">
<input type="hidden" name="op" value="post">
Name&nbsp;&nbsp;<input name="fullname" size=30 maxlength=60><p>
E-mail Address&nbsp;&nbsp;<input name="email" size=30 maxlength=128 ><p>
Comments:<br>
<TEXTAREA NAME="body" COLS=60 ROWS=8></textarea><p>
<input type="submit" value="Sign Guestbook">
<input type="reset" value="Clear">
</form>

BEGIN_MESSAGES
<hr>
    <b>Name</b>: ${maillink}<br>
    <b>Time</b>: 2000-04-15 20:00:00<br>
    <b>Comments</b>: ${body}
END_MESSAGES

  </body>
</html>
';

my $guestBook = "$directory/guestbook.txt";
my $templateFile;

if (defined $template) {
  $templateFile = $template;
} elsif (-f "$directory/guestbook-template.html") {
  $templateFile = "$directory/guestbook-template.html";
}

if(defined $templateFile) {
  open(IN, "$templateFile") || 
    die "Could not open $templateFile ($ERRNO)\n";
  $templateTxt = join("", <IN>);
  close(IN);
}

# Read /etc/passwd to get Unix user id
my $uid;
open(PASSWD, "</etc/passwd");
while(<PASSWD>) {
  my @line = split(":");
  if ($line[2] eq $UID) {
    $uid = $line[0];
    if (!defined $username) {
      $username = $line[4];
      if ($username eq "") {
	$username = $uid;
      } else {
	$username =~ s/,.*//g;
      }
    }
  }
}
close(PASSWD);

if (!defined $mail) {
  $mail = $uid;
}

$templateTxt =~ s/\$\{username\}/$username/ge;
$templateTxt =~ s/\$\{scriptname\}/$scriptName/ge;

if ($templateTxt !~ /(.*)BEGIN_MESSAGES(.*)END_MESSAGES(.*)/s) {
  die "No message text\n";
}

my $headerTxt   = $1;
my $msgTemplate = $2;
my $footerTxt   = $3;

################################################################
# End of default templates                                     #
################################################################


################################################################
# Get messages that have been posted so far                    #
################################################################
my $ip;
sub getMessages {
  my ($header, $msgBegun);
  my ($fullname, $email, $date, $body);
  if (! -f "$guestBook") {
    return ();
  }

  open (IN, "<$guestBook") || 
    die "Could not open $guestBook ($ERRNO)\n";
  my @messages = ();

  $header=1;
  $msgBegun=0;
  while(<IN>) {
    chomp;
    if ($header) {
      if (!$msgBegun) {
	$msgBegun=1;
      }
      if (/^Date: (.*)/) {
	$date = $1;
	next;
      }

      if (/^E-mail: (.*)/) {
	$email = $1;
	next;
      }

      if (/^IP: (.*)/) {
	$ip = $1;
	next;
      }

      if (/^From: (.*)/) {
	$fullname = $1;
	next;
      }

      if (/^$/) {
	$header = 0;
	next;
      }
    } else {
      if (/^\.$/) {
	$body =~ s/\n+$//g;
	unshift (@messages, {body=>$body, 
			     email=>$email,
			     date=>$date,
			     ip=>$ip,
			     fullname=>$fullname});
	$header = 1;
	$msgBegun=0;
	undef $date;
	undef $email;
	undef $fullname;
	$body="";
      } else {
	if (/^\.(\.*)$/) {
	  $_ = $1;
	}
	$body .= $_ . "\n";
      }
    }
  }
  close(IN);
  return @messages;
}

my @noSpam=();

sub checkSpam {
  my ($str) = @_;

  foreach my $word (@noSpam) {
    if(" $str " =~ /[^a-z]($word)[^a-z]/si) {
      print "Content-Type: text/html\n\n";
      print "Due to obnoxious spams, guestbook submissions containing the word \"".$query->escapeHTML($1)."\" are prohibited. Sorry for the inconvenience.<p>\n";
      print "<a href=\"$scriptName\">Try again</a>\n";
      exit(0);
    }
  }
}

if ($query->param('op') eq "post") {
  ################################################################
  # Post a message                                               #
  ################################################################

  # Scan antispam file, if it exists
  # Spam blacklist
  if(-f "$directory/nospam.txt") {
    open(NOSPAM, "<$directory/nospam.txt") ||
      die "Could not open $directory/nospam.txt ($ERRNO)\n";
    while(<NOSPAM>) {
      chomp;
      s/^\#.*//;  # Strip comments
      s/\s\#.*//;  # Strip comments
      s/^\s+//;  # Strip leading spaces
      s/\s+$//;  # Strip trailing spaces
      if($_ eq "") {
	next;
      }
      push(@noSpam, $_);
    }
    close(NOSPAM);
  }

  my $client_addr = $ENV{REMOTE_ADDR};

  # Scan blockedips file, if it exists
  if(-f "$directory/blockedips.txt") {
    open(BLOCKEDIP, "<$directory/blockedips.txt") ||
      die "Could not open $directory/blockedips.txt ($ERRNO)\n";
    while(<BLOCKEDIP>) {
      chomp;
      s/\#.*//;  # Strip comments
      s/^\s+//;  # Strip leading spaces
      s/\s+$//;  # Strip trailing spaces
      if($client_addr eq $_) {
	die "Posting from your IP is blocked\n";
      }
    }
    close(BLOCKEDIP);
  }

  if($iplog_script && $client_addr =~ /^[0-9.]*$/ ) {
    system($iplog_script, $client_addr);
  }

  my $signerEmail = $query->param('email');
  if (defined $signerEmail) {
    $signerEmail =~ s/[\r\n]+/ /g;
  }

  my $signerFullname = $query->param('fullname');
  if (defined $signerFullname) {
    $signerFullname =~ s/[\r\n]+/ /g;
  }

  my $body = $query->escapeHTML(scalar($query->param('body')));
  $body =~ s/\r\n?/\n/g;

  checkSpam($signerEmail);
  checkSpam($signerFullname);
  checkSpam($body);

  if ($signerFullname eq "" &&  $signerEmail eq "") {
    if (-f "$directory/whoru.html") {
      print $query->redirect("whoru.html");
    } else {
      print header;
      print "<html><head><title>Guestbook error</title></head><body bgcolor=\#ffffff><h1><center>Guestbook Error</center></h1>You need supply your name or your e-mail address</body></html><br>\n";
      print "<a href=\"$scriptName?read\">Click here to try again</a>\n";
      print "</html></body>\n";
    }
    exit(0);
  }

  my $date = localtime();

  open(OUT, ">>$guestBook") ||
    die "Could not open $guestBook\n";
  flock OUT, LOCK_EX;

  print OUT "Date: $date\n";

  if ($mail ne "") {
    my $from;
    open(PIPE, "|/usr/sbin/sendmail $mail");
    if ($signerEmail ne "") {
      $from = "$signerFullname".($signerFullname ne "" ? " ":"")."<$signerEmail>";
    } else {
      $from = "Guestbook Manager <root\@localhost>";
    }
    $from =~ s/[\r\n]+/ /g;
    print PIPE "To: $mail\n";
    print PIPE "From: $from\n";
    print PIPE "Subject: New Guestbook entry\n";
    print PIPE "\nA new entry has been added to your guestbook:\n\n";
    print PIPE "Date: $date\n";
    print PIPE "Ip: $ENV{REMOTE_ADDR}\n";
  }

  if (defined $signerFullname) {
    print OUT "From: $signerFullname\n";
    if ($mail ne "") {
      print PIPE "From: $signerFullname\n";
    }
  }

  if (defined $query->param('email')) {
    print OUT "E-mail: $signerEmail\n";
    if ($mail ne "") {
      print PIPE "E-mail: $signerEmail\n";
    }
  }

  print OUT "IP: $ENV{REMOTE_ADDR}\n";
  print OUT "\n";


  if ($mail ne "") {
    print PIPE "\n$body\n";
    close(PIPE);
  }

  foreach my $line (split("\n", $body)) {
    if ($line =~ /^(\.+)$/) {
      $line = ".$line";
    }
    print OUT "$line\n";
  }
  print OUT ".\n";
  flock OUT, LOCK_UN;
  close(OUT);

  #&Lock::unlock("$file");
  if (-f "$directory/thanks.html") {
    print $query->redirect("thanks.html");
  } else {
    print $query->redirect("$scriptName?op=read");
  }
  print "\n";
} else {
  ################################################################
  # Display the messages                                         #
  ################################################################
  print
    $query->header;
  print $headerTxt;

  my @messages=getMessages();

  foreach my $message (@messages) {
    my $text = $msgTemplate;
    my $maillink;

    if($message->{fullname} ne "") {
      $maillink = $message->{fullname};
    } else {
      $maillink = $message->{email};
    }
    $maillink = $query->escapeHTML($maillink);
    if ($message->{email}) {
      $maillink = "<a href=\"mailto:".$query->escape($message->{email}).
	"\">$maillink</a>";
    }


    $text =~ s/\$\{(date|email|fullname|ip)\}/$query->escapeHTML($message->{$1})."&nbsp;"/ge;
    $text =~ s/\$\{maillink\}/$maillink/ge;
    $message->{body} =~ s/\n/<br>\n/g;
    $text =~ s/\$\{body\}/$message->{body}/ge;
    print $text;
  }

  print $footerTxt;
}

1;
